UIPackage
Menu

Framework

Change language

Boilerplate repo

Command

commandui

Searchable command palette à la Cmd-K — keyboard-driven menu with grouped items, icons, shortcuts, and fuzzy filtering. Use as a global launcher (mounted in a Dialog) or inline as a typeahead select.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/command.json
Named registry:npx shadcn-vue@latest add @uipkge/commandInstalls to:app/components/ui/command/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
classHTMLAttributes['class']optional

Used by

Files installed (10)

  • app/components/ui/command/Command.vue2.3 kB
    <script setup lang="ts">
    import type { ListboxRootEmits, ListboxRootProps } from 'reka-ui'
    import type { HTMLAttributes } from 'vue'
    import { reactiveOmit } from '@vueuse/core'
    import { ListboxRoot, useFilter, useForwardPropsEmits } from 'reka-ui'
    import { reactive, ref, watch } from 'vue'
    import { cn } from '@/lib/utils'
    import { provideCommandContext } from '.'
    
    const props = withDefaults(defineProps<ListboxRootProps & { class?: HTMLAttributes['class'] }>(), {
      modelValue: '',
    })
    
    const emits = defineEmits<ListboxRootEmits>()
    
    const delegatedProps = reactiveOmit(props, 'class')
    
    const forwarded = useForwardPropsEmits(delegatedProps, emits)
    
    const allItems = ref<Map<string, string>>(new Map())
    const allGroups = ref<Map<string, Set<string>>>(new Map())
    
    const { contains } = useFilter({ sensitivity: 'base' })
    const filterState = reactive({
      search: '',
      filtered: {
        /** The count of all visible items. */
        count: 0,
        /** Map from visible item id to its search score. */
        items: new Map() as Map<string, number>,
        /** Set of groups with at least one visible item. */
        groups: new Set() as Set<string>,
      },
    })
    
    function filterItems() {
      if (!filterState.search) {
        filterState.filtered.count = allItems.value.size
        // Do nothing, each item will know to show itself because search is empty
        return
      }
    
      // Reset the groups
      filterState.filtered.groups = new Set()
      let itemCount = 0
    
      // Check which items should be included
      for (const [id, value] of allItems.value) {
        const score = contains(value, filterState.search)
        filterState.filtered.items.set(id, score ? 1 : 0)
        if (score) itemCount++
      }
    
      // Check which groups have at least 1 item shown
      for (const [groupId, group] of allGroups.value) {
        for (const itemId of group) {
          if (filterState.filtered.items.get(itemId)! > 0) {
            filterState.filtered.groups.add(groupId)
            break
          }
        }
      }
    
      filterState.filtered.count = itemCount
    }
    
    watch(
      () => filterState.search,
      () => {
        filterItems()
      },
    )
    
    provideCommandContext({
      allItems,
      allGroups,
      filterState,
    })
    </script>
    
    <template>
      <ListboxRoot
        data-uipkge
        data-slot="command"
        v-bind="forwarded"
        :class="
          cn('bg-popover text-popover-foreground flex h-full w-full flex-col overflow-hidden rounded-md', props.class)
        "
      >
        <slot />
      </ListboxRoot>
    </template>
    
  • app/components/ui/command/CommandDialog.vue1 kB
  • app/components/ui/command/CommandEmpty.vue0.8 kB
  • app/components/ui/command/CommandGroup.vue1.4 kB
  • app/components/ui/command/CommandInput.vue1.5 kB
  • app/components/ui/command/CommandItem.vue2.4 kB
  • app/components/ui/command/CommandList.vue0.7 kB
  • app/components/ui/command/CommandSeparator.vue0.6 kB
  • app/components/ui/command/CommandShortcut.vue0.4 kB
  • app/components/ui/command/index.ts1 kB

Raw manifest:https://uipkge.dev/r/vue/command.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Command

commandui

Searchable command palette à la Cmd-K — keyboard-driven menu with grouped items, icons, shortcuts, and fuzzy filtering. Use as a global launcher (mounted in a Dialog) or inline as a typeahead select.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/command.json
Named registry:npx shadcn@latest add @uipkge-react/commandInstalls to:components/ui/command/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
titlestringoptional
descriptionstringoptional

Used by

Files installed (2)

  • components/ui/command/command.tsx6.4 kB
    'use client'
    
    import * as React from 'react'
    import { Command as CommandPrimitive } from 'cmdk'
    import * as DialogPrimitive from '@radix-ui/react-dialog'
    import { Search } from 'lucide-react'
    import { cn } from '@/lib/utils'
    
    const Command = React.forwardRef<
      React.ElementRef<typeof CommandPrimitive>,
      React.ComponentPropsWithoutRef<typeof CommandPrimitive>
    >(({ className, ...props }, ref) => (
      <CommandPrimitive
        ref={ref}
        data-uipkge=""
        data-slot="command"
        className={cn(
          'bg-popover text-popover-foreground flex h-full w-full flex-col overflow-hidden rounded-md',
          className,
        )}
        {...props}
      />
    ))
    Command.displayName = CommandPrimitive.displayName
    
    interface CommandDialogProps extends React.ComponentPropsWithoutRef<typeof DialogPrimitive.Root> {
      title?: string
      description?: string
    }
    
    const CommandDialog = ({
      title = 'Command Palette',
      description = 'Search for a command to run...',
      children,
      ...props
    }: CommandDialogProps) => (
      <DialogPrimitive.Root {...props}>
        <DialogPrimitive.Portal>
          <DialogPrimitive.Overlay
            data-uipkge=""
            data-slot="command-dialog-overlay"
            className="data-[state=open]:animate-in data-[state=closed]:animate-out data-[state=closed]:fade-out-0 data-[state=open]:fade-in-0 fixed inset-0 z-50 bg-black/50"
          />
          <DialogPrimitive.Content
            data-uipkge=""
            data-slot="command-dialog"
            className="bg-background data-[state=open]:animate-in data-[state=closed]:animate-out data-[state=closed]:fade-out-0 data-[state=open]:fade-in-0 data-[state=closed]:zoom-out-95 data-[state=open]:zoom-in-95 fixed top-[50%] left-[50%] z-50 grid w-full max-w-lg translate-x-[-50%] translate-y-[-50%] gap-4 overflow-hidden rounded-lg border p-0 shadow-lg duration-200"
          >
            <DialogPrimitive.Title className="sr-only">{title}</DialogPrimitive.Title>
            <DialogPrimitive.Description className="sr-only">{description}</DialogPrimitive.Description>
            <Command className="[&_[cmdk-group-heading]]:text-muted-foreground [&_[cmdk-group-heading]]:px-2 [&_[cmdk-group-heading]]:font-medium [&_[cmdk-group]]:px-1 [&_[cmdk-input-wrapper]_svg]:size-5 [&_[cmdk-input]]:h-12 [&_[cmdk-item]]:px-2 [&_[cmdk-item]]:py-3 [&_[cmdk-item]_svg]:size-5">
              {children}
            </Command>
          </DialogPrimitive.Content>
        </DialogPrimitive.Portal>
      </DialogPrimitive.Root>
    )
    
    const CommandInput = React.forwardRef<
      React.ElementRef<typeof CommandPrimitive.Input>,
      React.ComponentPropsWithoutRef<typeof CommandPrimitive.Input>
    >(({ className, ...props }, ref) => (
      <div
        data-uipkge=""
        data-slot="command-input-wrapper"
        cmdk-input-wrapper=""
        className="flex h-9 items-center gap-2 border-b px-3"
      >
        <Search className="text-muted-foreground size-4 shrink-0" aria-hidden="true" />
        <CommandPrimitive.Input
          ref={ref}
          data-uipkge=""
          data-slot="command-input"
          className={cn(
            'placeholder:text-muted-foreground focus-visible:ring-ring/40 flex h-10 w-full rounded-md bg-transparent py-3 text-sm outline-hidden focus-visible:ring-2 focus-visible:outline-none disabled:cursor-not-allowed disabled:opacity-50',
            className,
          )}
          {...props}
        />
      </div>
    ))
    CommandInput.displayName = CommandPrimitive.Input.displayName
    
    const CommandList = React.forwardRef<
      React.ElementRef<typeof CommandPrimitive.List>,
      React.ComponentPropsWithoutRef<typeof CommandPrimitive.List>
    >(({ className, ...props }, ref) => (
      <CommandPrimitive.List
        ref={ref}
        data-uipkge=""
        data-slot="command-list"
        className={cn('max-h-[300px] scroll-py-1 overflow-x-hidden overflow-y-auto', className)}
        {...props}
      />
    ))
    CommandList.displayName = CommandPrimitive.List.displayName
    
    const CommandEmpty = React.forwardRef<
      React.ElementRef<typeof CommandPrimitive.Empty>,
      React.ComponentPropsWithoutRef<typeof CommandPrimitive.Empty>
    >(({ className, ...props }, ref) => (
      <CommandPrimitive.Empty
        ref={ref}
        data-uipkge=""
        data-slot="command-empty"
        className={cn('py-6 text-center text-sm', className)}
        {...props}
      />
    ))
    CommandEmpty.displayName = CommandPrimitive.Empty.displayName
    
    const CommandGroup = React.forwardRef<
      React.ElementRef<typeof CommandPrimitive.Group>,
      React.ComponentPropsWithoutRef<typeof CommandPrimitive.Group>
    >(({ className, ...props }, ref) => (
      <CommandPrimitive.Group
        ref={ref}
        data-uipkge=""
        data-slot="command-group"
        className={cn(
          'text-foreground [&_[cmdk-group-heading]]:text-muted-foreground overflow-hidden p-1 [&_[cmdk-group-heading]]:px-2 [&_[cmdk-group-heading]]:py-1.5 [&_[cmdk-group-heading]]:text-xs [&_[cmdk-group-heading]]:font-medium',
          className,
        )}
        {...props}
      />
    ))
    CommandGroup.displayName = CommandPrimitive.Group.displayName
    
    const CommandSeparator = React.forwardRef<
      React.ElementRef<typeof CommandPrimitive.Separator>,
      React.ComponentPropsWithoutRef<typeof CommandPrimitive.Separator>
    >(({ className, ...props }, ref) => (
      <CommandPrimitive.Separator
        ref={ref}
        data-uipkge=""
        data-slot="command-separator"
        className={cn('bg-border -mx-1 h-px', className)}
        {...props}
      />
    ))
    CommandSeparator.displayName = CommandPrimitive.Separator.displayName
    
    const CommandItem = React.forwardRef<
      React.ElementRef<typeof CommandPrimitive.Item>,
      React.ComponentPropsWithoutRef<typeof CommandPrimitive.Item>
    >(({ className, ...props }, ref) => (
      <CommandPrimitive.Item
        ref={ref}
        data-uipkge=""
        data-slot="command-item"
        className={cn(
          "data-[selected=true]:bg-accent data-[selected=true]:text-accent-foreground [&_svg:not([class*='text-'])]:text-muted-foreground relative flex cursor-default items-center gap-2 rounded-sm px-2 py-1.5 text-sm outline-hidden select-none data-[disabled=true]:pointer-events-none data-[disabled=true]:opacity-50 [&_svg]:pointer-events-none [&_svg]:shrink-0 [&_svg:not([class*='size-'])]:size-4",
          className,
        )}
        {...props}
      />
    ))
    CommandItem.displayName = CommandPrimitive.Item.displayName
    
    const CommandShortcut = ({ className, ...props }: React.HTMLAttributes<HTMLSpanElement>) => (
      <span
        data-uipkge=""
        data-slot="command-shortcut"
        className={cn('text-muted-foreground ml-auto text-xs tracking-widest', className)}
        {...props}
      />
    )
    CommandShortcut.displayName = 'CommandShortcut'
    
    export {
      Command,
      CommandDialog,
      CommandInput,
      CommandList,
      CommandEmpty,
      CommandGroup,
      CommandItem,
      CommandShortcut,
      CommandSeparator,
    }
    
  • components/ui/command/index.ts0.2 kB

Raw manifest:https://uipkge.dev/r/react/command.json